Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90	(revision 6772)
@@ -24,4 +24,5 @@
    USE trc_oce, ONLY : lk_offline ! offline flag
    USE crs
+   USE ieee_arithmetic
 
    IMPLICIT NONE
@@ -64,5 +65,4 @@
       REAL(wp) ::   zN2_c        ! local scalar
       INTEGER, POINTER, DIMENSION(:,:) ::   imld   ! 2D workspace
-      REAL(wp), POINTER, DIMENSION(:,:) ::  z2d   ! 2D workspace
       !!----------------------------------------------------------------------
       !
@@ -70,5 +70,4 @@
       !
       CALL wrk_alloc( jpi_crs,jpj_crs, imld )
-      CALL wrk_alloc( jpi_crs,jpj_crs, z2d )
 
       IF( kt == nit000 ) THEN
@@ -95,15 +94,11 @@
             iiki = imld(ji,jj)
             iikn = nmln_crs(ji,jj)
-            IF( iiki .NE. 0 ) hmld_crs (ji,jj) = ( gdepw_crs(ji,jj,iiki  ) - gdepw_crs(ji,jj,1 )            )   * tmask_crs(ji,jj,1)  ! Turbocline depth 
-            IF( iiki .NE. 0 ) hmlpt_crs(ji,jj) = ( gdept_crs(ji,jj,iikn-1) - gdepw_crs(ji,jj,1 )            )   * tmask_crs(ji,jj,1)  ! depth of the last T-point inside the mixed layer
+            hmld_crs (ji,jj) = ( fsdepw_crs(ji,jj,iiki  ) - fsdepw_crs(ji,jj,1    )  ) * tmask_crs(ji,jj,1)    ! Turbocline depth 
+            hmlp_crs (ji,jj) = ( fsdepw_crs(ji,jj,iikn  ) - fsdepw_crs(ji,jj,nla10)  ) * tmask_crs(ji,jj,1)    ! Mixed layer depth
+            hmlpt_crs(ji,jj) = ( fsdept_crs(ji,jj,iikn-1) - fsdepw_crs(ji,jj,1    )  ) * tmask_crs(ji,jj,1)    ! depth of the last T-point inside the mixed layer
          END DO
       END DO
       !
-      z2d=REAL(nmln_crs,wp)
-      CALL iom_put("nmln_crs",z2d)
-      CALL iom_put("hmlpt_crs",hmlpt_crs)
-      !
       CALL wrk_dealloc( jpi_crs,jpj_crs, imld )
-      CALL wrk_dealloc( jpi_crs,jpj_crs, z2d )
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_mxl_crs')
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_crs.F90	(revision 6772)
@@ -260,8 +260,8 @@
             DO ji = 2, jpi_crs-1   ! vector opt.
                DO jk = 2, jpkm1         ! from the surface to the bottom : lup
-                  zmxld_crs(ji,jj,jk) = MIN( zmxld_crs(ji,jj,jk-1) + e3t_crs(ji,jj,jk-1), zmxlm_crs(ji,jj,jk) )
+                  zmxld_crs(ji,jj,jk) = MIN( zmxld_crs(ji,jj,jk-1) + fse3t_crs(ji,jj,jk-1), zmxlm_crs(ji,jj,jk) )
                END DO
                DO jk = jpkm1, 2 , -1     ! from the bottom to the surface : ldown
-                  zmxlm_crs(ji,jj,jk) = MIN( zmxlm_crs(ji,jj,jk+1) + e3t_crs(ji,jj,jk+1), zmxlm_crs(ji,jj,jk) )
+                  zmxlm_crs(ji,jj,jk) = MIN( zmxlm_crs(ji,jj,jk+1) + fse3t_crs(ji,jj,jk+1), zmxlm_crs(ji,jj,jk) )
                END DO
             END DO
@@ -312,5 +312,5 @@
             DO ji = 2, jpi_crs-1   ! vector opt.
                DO jk = 2, jpkm1
-                  zcoef = avm_crs(ji,jj,jk) * 2._wp * e3w_crs(ji,jj,jk) * e3w_crs(ji,jj,jk)
+                  zcoef = avm_crs(ji,jj,jk) * 2._wp * fse3w_crs(ji,jj,jk) * fse3w_crs(ji,jj,jk)
                   !                                          ! shear
                   zdku = avmu_crs(ji-1,jj,jk) * ( un_crs(ji-1,jj,jk-1) - un_crs(ji-1,jj,jk) ) * ( ub_crs(ji-1,jj,jk-1) - ub_crs(ji-1,jj,jk) )   &
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 6772)
@@ -56,4 +56,5 @@
    USE ldfdyn          ! lateral viscosity setting      (ldfdyn_init routine)
    USE ldftra          ! lateral diffusivity setting    (ldftra_init routine)
+   USE ldftra_crs      ! lateral diffusivity setting    (ldftra_init routine)
    USE zdfini          ! vertical physics setting          (zdf_init routine)
    USE phycst          ! physical constant                  (par_cst routine)
@@ -118,5 +119,5 @@
       !!----------------------------------------------------------------------
       INTEGER ::   istp       ! time step index
-      CHARACTER(len=20) :: cmd 
+      CHARACTER(len=30) :: cmd 
       !!----------------------------------------------------------------------
       !
@@ -183,7 +184,12 @@
       IF(lwp) WRITE(numout,cform_aaa)   ! Flag AAAAAAA
       !
-      IF( nstop /= 0 .AND. lwp ) THEN   ! error print
+      IF( nstop /= 0 ) THEN   ! error print
+         cmd='touch nemo_NOK'
+         CALL system(cmd)
          WRITE(numout,cform_err)
          WRITE(numout,*) nstop, ' error have been found'
+      ELSE
+         cmd='touch nemo_OK'
+         CALL system(cmd)
       ENDIF
       !
@@ -460,4 +466,5 @@
       IF( ln_crs_top )      CALL dom_grid_crs
                             CALL     trc_init
+                            CALL ldf_tra_crs_init
       IF( ln_crs_top )      CALL dom_grid_glo
 #endif
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 6772)
@@ -257,7 +257,6 @@
                          CALL dom_grid_crs
 
-                         !CALL eos_rab_crs( tsn_crs, rab_crs_n )       ! now    local thermal/haline expension ratio at T-points
-                         !CALL bn2_crs    ( tsn_crs, rab_crs_n, rb2_crs  ) ! now    Brunt-Vaisala frequency
-                         CALL eos_crs ( tsn_crs, rhd_crs, rhop_crs, gdept_crs(:,:,:) ) ! now in situ density for hpg computation
+                         CALL zdf_mxl_crs(kstp)
+                         CALL eos_crs ( tsn_crs, rhd_crs, rhop_crs, fsdept_crs(:,:,:) ) ! now in situ density for hpg computation
                          CALL iom_put("rhop_crs",rhop_crs)
                          CALL iom_put("rhd_crs",rhd_crs)
@@ -270,5 +269,4 @@
 
       ENDIF
-                         CALL zdf_mxl_crs(kstp)
 
       IF( ln_crs_top )   CALL dom_grid_crs
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 6772)
@@ -98,4 +98,5 @@
    USE floats           ! floats computation               (flo_stp routine)
 
+   USE crs
    USE crsfld           ! Standard output on coarse grid   (crs_fld routine)
    USE zdfmxl_crs
